package org.jcg.zheng.dynamicinsert.repo;

import org.jcg.zheng.dynamicinsert.entity.DemoEntity;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
class DemoEntityRepoTest {

	private static final Logger logger = LoggerFactory.getLogger(DemoEntityRepoTest.class);

	@Autowired
	private DemoEntityRepo testRepo;
	private DemoEntity demoEntity = new DemoEntity();

	@Test
	void test_FirstName_only() {
		demoEntity.setFirstName("Mary");

		saveEntity(demoEntity);
	}

	@Test
	void test_Name_only() {
		demoEntity.setFirstName("Mary");
		demoEntity.setLastName("Zheng");

		saveEntity(demoEntity);
	}

	private void saveEntity(DemoEntity demoEntity) {
		logger.info("before save: " + demoEntity);
		demoEntity = testRepo.save(demoEntity);
		logger.info("after save: " + demoEntity);
	}

	@Test
	void test_Name_email() {
		demoEntity.setFirstName("Mary");
		demoEntity.setLastName("Zheng");
		demoEntity.setEmail("mary.s.zheng@jcg.org");

		saveEntity(demoEntity);
	}

}
